;
; * MIDI Keyboard controller for I8035 *
;--------------------------------------------------
;  Copyright (c) 1997 -    
;
;  Modified by Alexander Stepanov, 1998
;--------------------------------------------------
; ।  ஫:
;
; 20-27 -  ﭨ 
;         (   )
; 3E    - ﭨ 
; 3F    -  ᯮ㥬 MIDI-
;
$ALLPUBLIC

            DEFSEG  ABSOLUTE,START=0
            SEG     ABSOLUTE

            MOV     A,#0FFH           ; 1  MIDI-䥩 - ⮯-
            OUTL    P2,A
            NOP                       ;  ६ 뤠 ⮯-
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            CALL    S180        ; 樠
;
;  横 ᪠஢
;
L1E:        MOV     R7,#64H     ;  R7 - ᫮ 室  Active Sence
;
;  ᪠஢  Active Sense
;
L20:        MOV     R4,#00H     ;  R4 - # ᪠㥬 
            MOV     R0,#20H     ;  R0 - H砫   ﭨ
            MOV     R2,#08H     ;  R2 - 稪 ⮢  
;
;  ᪠஢  ⠬  
;
L26:        MOV     R3,#08H     ;  R3 - 稪 ⮢   ﭨ
            MOV     A,@R0       ;  砥 ।   
;
;  ᪠஢  ⠬    
;
L29:        XCH     A,R4
            OUTL    P1,A        ; 뢮 #   䥩
                                ;  T0 뢠 ﭨ :
                                ;       0 - 
                                ;       1 - 饭
            XCH     A,R4        ;  A -   
            CLR     C
            JT0     L50         ;  ? - , Note on
            RRC     A           ; ᤢ A, ய뢠  
                                ;   饭 ( C=0 )
                                ; ஥ ﭨ   -> C                               ;    -  
            JC      LB0         ; 뫠 ? - Note off
L32:        INC     R4          ; # ᫥饩 
            DJNZ    R3,L29      ; 蠥 横  ⠬

            MOV     @R0,A       ; ࠭塞 ⥪饥 ﭨ 
                                ;  
            INC     R0          ;  ᫥饣   
            DJNZ    R2,L26      ; 蠥 横  ⠬
;
; ஢ઠ MIDI - 
;
            MOV     R0,#3Eh     ; ﭨ 
            MOV     A,@R0
            JT1     MM1
            RL      A
            JZ      MM3
            CLR     A           ; 頥 ﭨ
            MOV     @R0,A
            MOV     R1,#3FH     ;
            MOV     A,@R1       ; # MIDI-
            ADD     A,#0B0H     ;   Bx
            MOV     R1,A
            CALL    SEND        ; 뢮   䥩
            MOV     R1,#40H
            CALL    SEND
            MOV     R1,#0
            CALL    SEND
            JMP     MM3
MM1:        RL      A
            JNZ     MM3
            INC     A
            MOV     @R0,A
            MOV     R1,#3FH     ;
            MOV     A,@R1       ; # MIDI-
            ADD     A,#0B0H     ;   Bx
            MOV     R1,A
            CALL    SEND        ; 뢮   䥩
            MOV     R1,#40H
            CALL    SEND
            MOV     R1,#07Fh    ; ᪠ 
            CALL    SEND
;------------------
MM3:        DJNZ    R7,L20      ; 蠥 64h 横 ᪠஢ 

            MOV     R1,#0FEH
            CALL    SEND        ; 뢮 Active Sence

            JMP     L1E         ;   ᭠砫...

;
; ஢ઠ ⮣ ﭨ 
;
L50:        CPL     C           ; =1
            RRC     A           ; 뢠   ,
                                ; ।饥 ﭨ -> C
            JNC     L80         ;  뫠 饭
            JMP     L32         ; ࠭ 뫠  - 祣  
;
; ࠡ⪠  
;
L80:        XCH     A,R5        ; ࠭塞 A
            MOV     R1,#3FH     ;
            MOV     A,@R1       ; # MIDI-
            ADD     A,#90H      ;   9x - Note on
            MOV     R1,A
            CALL    SEND        ; 뢮   䥩
            MOV     A,R4        ; # 
            ADD     A,#24H      ; ᤢ  ॠ쭮    24-60
            MOV     R1,A
            CALL    SEND        ; 뢮 # 
            MOV     R1,#3FH
            CALL    SEND        ; 뢮 ⨢ - 3F
            XCH     A,R5        ; ⠭ A
            JMP     L32         ; த 横
;
; ࠡ⪠ ᪠ 
;
LB0:        XCH     A,R5        ; ࠭塞 A
            MOV     R1,#3FH
            MOV     A,@R1       ; # MIDI-
            ADD     A,#80H      ;   8x - Note off
            MOV     R1,A
            CALL    SEND        ; 뢮 
            MOV     A,R4        ; # 
            ADD     A,#24H      ; ᤢ  
            MOV     R1,A
            CALL    SEND        ; 뢮 
            MOV     R1,#3FH
            CALL    SEND        ; 뢮 ᪮ ᪠ - 3F
            XCH     A,R5        ; ⠭ A
            JMP     L32         ; த 横
;
; 楤 뤠   MIDI-䥩
;
SEND:       MOV     A,#00H      ; 0 - ⮢ 
            OUTL    P2,A        ; 뢮 
            MOV     A,R1        ; 뢮 
            RL      A           ; ᤢ 4 ࠧ
            RL      A           ;  䥩 ࠧ - 2.4
            RL      A
            RL      A
            MOV     R1,#08H     ; 稪 ⮢
            NOP                 ; 㧠  ⠬
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
L114:       OUTL    P2,A       ; 뢮 । 
            RR      A          ; ᤢ
            NOP                ; 㧠  ⠬
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            DJNZ    R1,L114  ; 뢮 ⠫ 
            MOV     A,#0FFH
            OUTL    P2,A     ; ⮯- - 1
            MOV     R1,#0AH
L12B:       DJNZ    R1,L12B ; 㧠 -  ⮯-
            RET
;
; 楤 樠樨
;  롮 # MIDI-
;
S180:       MOV     R0,#3FH
            MOV     @R0,#00H    ;  㬮砭 - 1 
            DEC     R0
            MOV     @R0,#00h
            MOV     R0,#20H     ; ⮢   ﭨ
            MOV     R1,#08H     ;  
L188:       MOV     @R0,#00H    ; 頥 
            INC     R0
            DJNZ    R1,L188
;
;  塞,       16  -
;  ⠭ # 
;
L18F:       MOV     A,R3        ; # ⥪饩 
            DEC     A
            OUTL    P1,A        ; 뢮  䥩
            JT0     L197        ; ?
            DJNZ    R3,L18F     ;  - 訢 
            RET                 ; 祣  
;
; ᫨  
;
L197:       MOV     R0,#3FH
            MOV     @R0,A       ; 뢠 ⠭ # 
L19A:       JT0     L19A       ;  ᪠ 
            RET

            end
